<?php 
/* Copyright (C) 2008 Zachary Lund and Ryan Ozechowski */

if (isset($_GET["ajax"]))
{
	// it's an AJAX call...
	if (isset($_GET["playlist"]))
		$selectedPlaylist = $_GET["playlist"];
	
	if (isset($_GET["search"]))
		$search = strtolower($_GET["search"]);
	else
		$search = "";
	
	if (isset($_GET["random"]))
		$random = strtolower($_GET["random"]);
	else
		$random = "";
	
	$xml = simplexml_load_file($convertedLibraryPath);
	
	$trackXMLArray = array();
	$evenOdd=0;
	
	foreach ($xml->dict->Playlists->dict as $playlist)
	{
		if ($playlist->Name == $selectedPlaylist && count($playlist->Playlist_Items) > 0)
		{
			foreach($playlist->Playlist_Items->dict as $plSong)
			{
				$track_id = "number_" . $plSong->Track_ID;
				$song = $xml->dict->Tracks->dict->$track_id;
					
				if (
					!$search || 
					strpos(strtolower($song->dict->Name), $search) > -1 ||
					strpos(strtolower($song->dict->Artist), $search) > -1 ||
					strpos(strtolower($song->dict->Album), $search) > -1
					)
				{
					$trackXML = "<track>";
					$trackXML .= "<id>" . $plSong->Track_ID . "</id>";
					$trackXML .= "<name>" . processForXML($song->dict->Name) . "</name>";
					$trackXML .= "<artist>" . processForXML($song->dict->Artist) . "</artist>";
					$trackXML .= "<album>" . processForXML($song->dict->Album) . "</album>";
					$trackXML .= "<genre>" . processForXML($song->dict->Genre) . "</genre>";
					$trackXML .= "<time>" . convertTimestamp($song->dict->Total_Time) . "</time>";
					$trackXML .= "</track>";
					$trackXMLArray[] = $trackXML;
				}
			}
			break;
		}
	}
	
	header("Content-type: application/xml");
	echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>";
	echo "<root>";
	echo "<tracks>";
	if ($random != "")
	{
		if ($random > 0)
		{
			for ($i = 0; $i < count($trackXMLArray); $i++)
			{
				if (strpos($trackXMLArray[$i], $random) !== false)
				{
					echo $trackXMLArray[$i];
					unset($trackXMLArray[$i]);
				}
			}
		}
		while (count($trackXMLArray) > 0)
		{
			$num = array_rand($trackXMLArray);
			echo $trackXMLArray[$num];
			unset($trackXMLArray[$num]);
		}
	}
	else
	{
		foreach($trackXMLArray as $trackXML)
			echo $trackXML;
	}
	echo "</tracks>";
	echo "</root>";
	
	die();
}

?>
